#include <s1c33cpu.h>
#include <string.h>
#include <stdio.h>
#include <piece.h>
#include "mmc_api.h"
#include "mmc_api2.h"

//---------------------------------------------------------------------------
// WX^ANZX` 
//---------------------------------------------------------------------------
//eWX^ւ̃AhX

//o͌p|[g֘A
//CPUf[^V[gP.370,P.372Q
#define P0D		(*(volatile unsigned char*)0x402D1)		//P0o͌p|[gf[^WX^
#define P1D		(*(volatile unsigned char*)0x402D5)		//P1o͌p|[gf[^WX^

//}N`
#define CARD_ENABLE		{ P1D &= ~(1 << 4); }			//J[hActiveɂ܂
#define CARD_DISABLE	{ P1D |=  (1 << 4); }			//J[hNonActiveɂ܂	
//---------------------------------------------------------------------------
// t@C萔` 
//---------------------------------------------------------------------------
#define MMC_RECV_TIMEOUT		0xFFFF		//M^CAEgl

//---------------------------------------------------------------------------
// t@C\̒` 
//---------------------------------------------------------------------------
//MMC̏\
typedef struct tag_MMC_INFO
{
	unsigned char bInit;		//ς݃tO
	
	MMC_CID_INFO tCIDInfo;		//CID
	MMC_CSD_INFO tCSDInfo;		//CSD

} MMC_INFO;

//---------------------------------------------------------------------------
// t@CO[oϐ` 
//---------------------------------------------------------------------------
static MMC_INFO			g_tMMCInfo;

//---------------------------------------------------------------------------
// t@Ĉ݂̊֐vg^Cv錾 
//---------------------------------------------------------------------------

//1oCgM
inline void mmcByteSend(unsigned char ucData);

//f[^̑MRA
void mmcSendDataCore(unsigned char *paData,int iDataLen);

//R}hMX|XM
//CMD13R2X|X(2bytes)
unsigned short mmcSendCommandAndRecvResponse(unsigned char ucCMD,unsigned long ulArg);

//1oCgM
inline unsigned char mmcByteRecv(void);

//f[^M
//X^[grbgȍ~̎w̃oCgM܂
//^CAEgꍇ0Ԃ܂BI1Ԃ܂B
unsigned char mmcRecvData(unsigned char *paRecvBuff,int iRecvLen);

//---------------------------------------------------------------------------
// ֐Cvg 
//---------------------------------------------------------------------------
void mmcByteSend(unsigned char ucData)
{

	//1oCgM

	//f[^̓NbN̗オŎ擾̂ŁA
	//NbNLowɂĂf[^ZbgANbN
	//HighɂMMCɎ擾Ă炢܂B
	//f[^MSB瑗M܂
	
	//قƂP/ECẼNbNVAʐM̋@\
	//g΂ƊȒPɍɃf[^̑Ms͂
	//ȂłAfBMP07|[gHighɌŒ肳
	//̂ŁANbNł͐ɒʐMłȂ̂łB
	//cOłˁB

	int i;

	for(i = 0;i < 8;++i)
	{
		
		//NbNLow
		//(P06Low)
		P0D &= ~(1 << 6);
		
		//f[^Zbg
		//(P05ɃrbgZbg)
		P0D &= ~(1 << 5);		//[NA
		P0D |= (((ucData << i) & 0x80) >> 2);

		//NbNHigh
		//(P06High)
		P0D |= (1 << 6);
		
	}

}
//---------------------------------------------------------------------------
void mmcSendDataCore(unsigned char *paData,int iDataLen)
{

	//f[^̑MRA
	
	//_~[NbN𑗂ȂMMCŐFX
	//ĂȂȂ̂Œ
	int i;
	
	//8NbÑ_~[M
	mmcByteSend(0xFF);
	
	//w̃oCgf[^𑗐M
	for(i = 0;i < iDataLen;++i)
	{
		//PoCgM
		mmcByteSend(paData[i]);
	}

	//8NbÑ_~[M
	mmcByteSend(0xFF);

}
//---------------------------------------------------------------------------
unsigned short mmcSendCommandAndRecvResponse(unsigned char ucCMD,unsigned long ulArg)
{

	//R}hMX|XM
	//CMD13R2X|X(2bytes)
	unsigned short usRes = 0xFFFF;		//X|X
	unsigned char ucWork;				//ꎞL
	unsigned char ucaCommand[6];		//R}hf[^
	int i;

	//R}hf[^̍쐬

	//R}hZbg
	ucaCommand[0] = (0x40 | ucCMD);
	
	//Zbg
	for(i = 4;i > 0;--i)
	{
		ucaCommand[i] = (unsigned char)(ulArg & 0xFF);
		ulArg >>= 8;
	}

	//CRCZbg
	ucaCommand[5] = 0xFF;	//_~[

	//R}hM
	mmcSendDataCore(ucaCommand,6);

	//X|XM
	if(mmcRecvData(&ucWork,1) == 1)
	{
		//X|X擾
		usRes = ucWork;

		//̂CMD13H
		if(ucCMD == 13)
		{
			//̂ʂɂ炷
			usRes <<= 8;

			//c1oCgM
			if(mmcRecvData(&ucWork,1) == 1)
			{
				
				usRes |= (unsigned short)ucWork;

			}
			else usRes = 0xFFFF;	//s
		}
	}

	return usRes;

}
//---------------------------------------------------------------------------
unsigned char mmcByteRecv(void)
{

	//1oCgM
	
	unsigned char ucRes = 0xFF;
	int i;

	//OUTHighɂĂ
	P0D |= (1 << 5);		
	
	//M[v
	for(i = 0;i < 8;++i)
	{
	
		//NbNLow
		//(P06Low)
		P0D &= ~(1 << 6);

		//NbNHigh
		//(P06High)
		P0D |= (1 << 6);

		//f[^擾
		//(P04f[^擾)
		ucRes <<= 1;
		ucRes |= ((P0D & (1 << 4)) >> 4);
	
	}
	
	return ucRes;

}
//---------------------------------------------------------------------------
unsigned char mmcRecvData(unsigned char *paRecvBuff,int iRecvLen)
{

	//f[^MRA
	//X^[grbgȍ~̎w̃oCgM܂
	//^CAEgꍇ0Ԃ܂BI1Ԃ܂B

	unsigned long l;
	int iIndex = 0;						//Mobt@̃CfbNX
	unsigned long ulBitCount = 0;		//Mrbg
	unsigned char ucWork = 0;			//ꎞL

	//OUTHighɂĂ
	P0D |= (1 << 5);

	//X^[grbg(0)܂ő҂
	for(l = 0;l < MMC_RECV_TIMEOUT;++l)
	{

		//NbNLow
		//(P06Low)
		P0D &= ~(1 << 6);

		//NbNHigh
		//(P06High)
		P0D |= (1 << 6);

		//f[^擾
		//(P04f[^擾
		ucWork = (P0D & (1 << 4));
		
		//X^[grbg(0)oH
		if(ucWork == 0)
			break;

	}

	//^CAEgH
	if(l == MMC_RECV_TIMEOUT)
	{
#if 0
		#define MMC_RECV_TIMEOUTERR	"MMC_RECV_TIMEOUTERR"
		SendUsbCom(MMC_RECV_TIMEOUTERR,strlen(MMC_RECV_TIMEOUTERR));	
		mmcWait(USBCOM_WAIT);
#endif
		return 0;			//^CAEg0Ԃ
	}

	//R1 or R1X|XMH
	if(iRecvLen <= 2)
	{
        //X^[grbgۑ
		paRecvBuff[iIndex] = 0;

		//1rbgMς݂
		ulBitCount++;
	}

	//̃f[^M
	while(iIndex < iRecvLen)
	{
		
		//NbNLow
		//(P06Low)
		P0D &= ~(1 << 6);

		//NbNHigh
		//(P06High)
		P0D |= (1 << 6);

		//f[^擾
		//(P04f[^擾
		paRecvBuff[iIndex] <<= 1;						//i[ꏊm
		paRecvBuff[iIndex] |= ((P0D & (1 << 4)) >> 4);	//1bit擾

		//MrbgXV
		ulBitCount++;

		//i[obt@̃CfbNXZo
		//(8Ŋ = E3Vtg)
		iIndex = (int)(ulBitCount >> 3);

	}

	return 1;

}

/*
																	
	́AMMCΉJ[l Ver 1.25  mmc_api.c ̔ł	
																	
*/

unsigned char mmcInitCore2(void)
{
	//CID̎擾
	if(mmcGetCIDInfo(&g_tMMCInfo.tCIDInfo) == 0)
		return 0;	//擾s

	//CSD̎擾
	if(mmcGetCSDInfo(&g_tMMCInfo.tCSDInfo) == 0)
		return 0;	//擾s

	//I
	g_tMMCInfo.bInit = 1;	//ς݃tOON

	//I
	return 1;
}

static unsigned char mmcWaitBusy(void)
{

	//rW[҂
	
	unsigned long l;
	unsigned char ucWork;			//BusyrbgꎞL

	//OUTHighɂĂ
	P0D |= (1 << 5);		
	
	//rW[(1)܂ő҂
	for(l = 0;l < MMC_RECV_TIMEOUT;++l)
	{
	
		//NbNLow
		//(P06Low)
		P0D &= ~(1 << 6);

		//NbNHigh
		//(P06High)
		P0D |= (1 << 6);

		//f[^擾
		//(P04f[^擾)
		ucWork = (P0D & (1 << 4));
		
		//rW[(1)oH
		if(ucWork != 0)
			break;
	
	}
	
	//^CAEgH
	//(BUFFALO RSDC-32Mł4000`5000[v炢݂ł)
	if(l == MMC_RECV_TIMEOUT)
	{
		return 0;			//^CAEg0Ԃ
	}
	
	return 1;

}

//ZN^Cg(჌xMMC֐)
//MMC1ZN^(512oCgz)f[^݂܂B
//
//unsigned long ulSector	ǂݏoΏۃZN^(ZN^ԍ)
//const unsigned char *pBuff	obt@(K512oCgȏ゠邱)
//
//ɓǂݏoꍇ1AG[ꍇ0Ԃ܂
unsigned char mmcWriteSector(unsigned long ulSector,const unsigned char *pucBuff)
{

	//ZN^Cg
	//MMC1ZN^(512oCgz)f[^݂܂
	//
	//      unsigned long ulSector	ǂݏoΏۃZN^(ZN^ԍ)
	//const unsigned char *pBuff	obt@(K512oCgȏ゠邱)
	//
	//ɓǂݏoꍇ1AG[ꍇ0Ԃ܂
	unsigned long ulAddress = ulSector * g_tMMCInfo.tCSDInfo.usReadBlockLength;	//AhX
	unsigned char ucRet = 0;		//߂lɐݒ肷
	unsigned char ucWork1;			//f[^X|Xg[N󂯎
	unsigned char ucWork2;			//rW[҂̌ʂ󂯎
	int iIndex;						//Mobt@̃CfbNX

	// * AmmcInit()Ă΂mmcWriteSector()Ă΂ƁA
	//   g_tMMCInfo.tCSDInfo.usReadBlockLength0̂܂܂Ȃ̂ŁAulAddresšvZʂ͏0ƂȂA
	//   Ȃ킿MBȐɂȂĂ܂܂B
	//   Ɋ댯ł̂ŁAZN^#0̏͂łȂ悤ɂ܂B
	// * IulSector0w肵mmcWriteSector()ĂтꍇAsƂ܂B
	//   Ƃ΁AtH[}bgulSector=0̏AsƂ邽߁A
	//   {vOłMMC/SDJ[htH[}bgł܂B
	//   ܂펞gp̂łȂ̂ŁAtH[}bgłȂƂŜ܂B
	if(ulAddress != 0)
	{

		//J[hActive
		CARD_ENABLE

		//CMD24MR1X|XM
		if(mmcSendCommandAndRecvResponse(24,ulAddress) == 0x00)
		{

			// [Ql]
			// http://www.renesas.com/avs/resource/japan/jpn/pdf/flashcard/j203658_hb28e016mm2.pdf
			// p.64 f[^X|XAf[^g[N
			// p.70 SPIoX^C~OEVOubNCg

			//8NbÑ_~[M(Nwr)
			mmcByteSend(0xFF);

			//{{f[^ubNMJn

			//X^[gf[^ubNg[NM
			mmcByteSend(0xFE);

			//[Uf[^M
			for(iIndex = 0;iIndex < g_tMMCInfo.tCSDInfo.usReadBlockLength;++iIndex)
			{
				mmcByteSend(pucBuff[iIndex]);
			}

			//16rbgCRCM (SPI[h͏ԂCRC OffȂ̂Ń_~[ō\܂)
			mmcByteSend(0xFF);
			mmcByteSend(0xFF);

			//}}f[^ubNM

			//f[^ubNMɁAf[^X|Xg[Nԑ܂B
			//f[^ubNM̌ɁA_~[̑MNbNĂ͂܂B
			//f[^X|Xg[Nɂ́AX^[grbg͂܂B
			//
			//]kłǁArW[܂ŏ݂͏IĂȂ͂Ȃ̂ɁA
			//  Ȃɐ旧"110"CgG[oł̂svcł...
			
			//f[^X|Xg[NM
			// xxx0sss1
			// |||||||+- 1Œ
			// ||||+++-- status "010"-f[^󂯓ꂽB
			// ||||             "101"-CRCG[ɂf[^͋ۂꂽB
			// ||||             "110"-CgG[ɂf[^͋ۂꂽB
			// |||+----- 0Œ
			// +++------ s(BUFFALO RSDC-32Mł111ƂȂ悤ł)
			ucWork1 = mmcByteRecv();

			//rW[҂
			ucWork2 = mmcWaitBusy();

			//f[^X|Xg[Ngf[^󂯓ꂽhŁA
			//rW[҂^CAEgłȂ΁A
			//ݐA1Ԃ
			if(((ucWork1 & 0x1F) == 0x05) && (ucWork2 == 1))
			{
				ucRet = 1;
			}

		}
		
		//J[hNonActive
		CARD_DISABLE

	}

	return ucRet;

}
